package cn.estsh.i3plus.ext.mes.pcn.apiservice.serviceimpl.rulematch.containerbind.checkqty;

import cn.estsh.i3plus.ext.mes.pcn.pojo.model.MesContainerPartsModel;
import cn.estsh.i3plus.ext.mes.pcn.pojo.util.MesPcnExtConstWords;
import cn.estsh.i3plus.pojo.mes.bean.MesContainerPackage;
import cn.estsh.i3plus.pojo.mes.bean.MesContainerPackageDetail;
import cn.estsh.i3plus.pojo.mes.util.MesExtEnumUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Objects;

@Slf4j
@Component
public class MesContainerBindNotMixService extends MesAbstractContainerBindCheckQtyService {
    public MesContainerBindNotMixService() {
        super(MesExtEnumUtil.CONTAINER_TYPE_MIX_TYPE.MIX_TYPE_10);
    }

    @Override
    public Map<String, Object> doCheck(String organizeCode, MesContainerPackage containerPackage, List<MesContainerPackageDetail> packageDetails, MesContainerPartsModel matchModel, List<MesContainerPartsModel> containerParts) {
        Map<String, Object> result = new HashMap<>();
        result.put(MesPcnExtConstWords.RESULT, false);

        for (MesContainerPartsModel containerPart : containerParts) {
            if (!Objects.equals(containerPart.getPartNo(), matchModel.getPartNo())) {
                continue;
            }

            if (containerPackage.getQty() >= containerPart.getQty()) {
                result.put(MesPcnExtConstWords.MESSAGE, String.format("容器条码【%s】超出了包装规格", containerPackage.getContainerSn()));
                return result;
            }
            if ((containerPackage.getQty() + 1) == containerPart.getQty()) {
                containerPackage.setPackageStatus(MesExtEnumUtil.CONTAINER_PACKAGE_STATUS.STATUS_20.getValue());
            }
        }

        result.put(MesPcnExtConstWords.RESULT, true);
        return result;
    }
}
